codeforces 225C Barcode

题意:给你一个矩阵,只包含 ‘#‘ 和 ‘.‘,现在每一列必须相同,最多连续y列最少连续x列相同。

解题思路:3维dp,dp[i][j][k] 表示 第i列 ,状态j,是状态j的第K行。

解题代码:

  1 // File Name: 225c.cpp
  2 // Author: darkdream
  3 // Created Time: 2015年03月09日 星期一 09时49分05秒
  4 #include<climits>
  5 #include<vector>
  6 #include<list>
  7 #include<map>
  8 #include<set>
  9 #include<deque>
 10 #include<stack>
 11 #include<bitset>
 12 #include<algorithm>
 13 #include<functional>
 14 #include<numeric>
 15 #include<utility>
 16 #include<sstream>
 17 #include<iostream>
 18 #include<iomanip>
 19 #include<cstdio>
 20 #include<cmath>
 21 #include<cstdlib>
 22 #include<cstring>
 23 #include<ctime>
 24 #define LL long long
 25 using namespace std;
 26 char str[1005][1005];
 27 int dp[1005][2][1005];
 28 int cw[1005];
 29 int cb[1005];
 30 int main(){
 31   int n , m ,x ,y;
 32   memset(dp,-1,sizeof(dp)) ;
 33   scanf("%d %d %d %d",&n,&m,&x,&y);
 34   for(int i = 1;i <= n;i ++)
 35   {
 36      scanf("%s",&str[i][1]);
 37   }
 38   for(int i = 1;i <= m;i ++)
 39   {
 40     for(int j = 1;j <= n;j ++)
 41     {
 42       if(str[j][i] == ‘#‘)
 43           cw[i] ++ ;
 44     }
 45     cb[i] = n - cw[i];
 46   }
 47   dp[1][0][1] = cb[1];
 48   dp[1][1][1] = cw[1];
 49   for(int i= 2;i <= m;i ++)
 50   {
 51      int mxcb = -1;
 52      for(int j = 1;j <= y ;j ++)
 53      {
 54           if(dp[i-1][0][j] != -1)
 55           {
 56             dp[i][0][j+1] = dp[i-1][0][j] + cb[i];
 57             if(j >= x)
 58             {
 59              if(mxcb == -1)
 60                  mxcb = dp[i-1][0][j];
 61              else
 62                  mxcb = min(mxcb,dp[i-1][0][j]);
 63             }
 64           }
 65      }
 66      int mxcw = -1;
 67      for(int j = 1;j <= y ;j ++)
 68      {
 69           if(dp[i-1][1][j] != -1)
 70           {
 71             dp[i][1][j+1] = dp[i-1][1][j] + cw[i];
 72             if(j >= x)
 73             {
 74              if(mxcw == -1)
 75                  mxcw = dp[i-1][1][j];
 76              else
 77                  mxcw = min(mxcw,dp[i-1][1][j]);
 78             }
 79           }
 80      }
 81      //printf("%d %d\n",mxcw,mxcb);
 82      if(mxcw != -1)
 83          dp[i][0][1] = mxcw + cb[i];
 84      if(mxcb != -1)
 85          dp[i][1][1] = mxcb + cw[i];
 86   }
 87   int ans = INT_MAX;
 88   for(int i = 0 ;i < 2;i ++)
 89       for(int j = x; j <= y; j ++)
 90       {
 91         if(dp[m][i][j] != -1)
 92           ans = min(dp[m][i][j],ans);
 93       }
 94   /*for(int i = 1;i <= m;i ++)
 95   {
 96    for(int s = 0 ; s <= 1 ; s ++)
 97    {
 98     for(int j= 1;j <= y ;j ++)
 99         printf("%d ",dp[i][s][j]);
100      printf("****");
101    }
102     printf("\n");
103   }*/
104   printf("%d\n",ans);
105 return 0;
106 }

时间: 2024-07-31 10:04:44

codeforces 225C Barcode的相关文章

CodeForces 225C Barcode DP

也是一道dp ,想到了就会觉得很巧妙 矩阵中只有白块和黑块,要求repaint后满足下述条件: 每列一种颜色 根据输入范围x, y 要求条纹宽度在[x, y] 之间 数据范围: n, m, x and y (1 ≤ n, m, x, y ≤ 1000; x ≤ y). 求:满足条件最少repaint的次数 自己在YY的时候觉得这么大的数据范围肯定没得暴力,估计就dp 了= = 是可以想出这么个dp 公式: cur[][] = Sigma(x ~ y) Min( former[][] + Sum[

Codeforces Round #139 (Div. 2)C Barcode DP

#include<iostream> #include<cstdio> #include<cstring> using namespace std ; const int maxn = 1010; const int inf = 0x3f3f3f3f ; int dp[maxn][2] ; char str[maxn][maxn] ; int num[maxn]; int sum_b[maxn]; int sum_w[maxn]; int main() { // fre

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl